	@echo off
	rem *********************************************************************
	rem *  Filename : hyperjuke-pack.bat
	rem *  An archive file creation program
	rem *  Copyright(C) 1996 Fumio Kawamata
	rem *
	rem * This batch program creats an archive for distribution.
	rem * The program compress files into an archive file in the hard
	rem * disk directory, and uncompress it for make sure.
	rem *
	rem * You need following programs when you execute this batch program.
	rem *   - Info-Zip's zip and unzip compression utility programs
	rem *   - rm, cp, and touch programs which run like UNIX programs
	rem * 
	rem * Remember that this batch program is designed for the author's
	rem * program environment.  Modify this program if you want use this. :-)
	rem *********************************************************************

:SetEnv
	rem *********************************************************************
	rem *  Sets environmet for program
	rem *********************************************************************
	set TimeStamp=04:02:00
	set DestName=c:\tmp\hj402.zip
	set DBName=database.zip
	set TestDir=c:\tmp\hj402
	set LogFile=c:\tmp\ziplog.txt


:Confirm
	rem *********************************************************************
	rem *  Confirms program parameters
	rem *********************************************************************
	cls
	echo This batch program will make an archive file.
	echo Zip File                 : %DestName%
	echo Time Stamp               : %TimeStamp%
	echo Test Directory           : %TestDir%
	echo Log File Name            : %LogFile%
	echo --------------------------------------------------------
	echo Hit any key.
	pause>nul


	rem *********************************************************************
	rem *  Removes garbage files
	rem *********************************************************************
	cd e:\hyperjuke
	echo Removing src\*.~*
	rm src\*.~*>>%LogFile%
	echo Removing bin\*.dcu
	rm bin\*.dcu>>%LogFile%
	echo Removing ..\hyperjuke_db\*.dcu
	rm ..\hyperjuke_db\*.dcu>>%LogFile%
	echo Removing %DestName%
	if exist %DestName% rm %DestName%>>%LogFile%
	echo Removing %DBName%
	if exist %DBName%   rm %DBName%>>%LogFile%
	echo Removing %TestDir%
	rm -R -f %TestDir%>>%LogFile%
	echo Finished

	rem *********************************************************************
	rem *  Touching files 1
	rem *********************************************************************
	echo Touching hyperjuke.exe ...
	touch -t%TimeStamp% bin\hyperjuke.exe>>%LogFile%
	touch -r -e\hyperjuke\bin\hyperjuke.exe  e:\hyperjuke_db\*>>%LogFile%

	rem *********************************************************************
	rem *  Zipping database
	rem *********************************************************************
	echo Zipping \hyperjuke_db into %DBName% ...
	cd \HyperJuke_DB
	zip -r ..\HyperJuke\%DBName% *>>%LogFile%

	rem *********************************************************************
	rem *  Touching files 2
	rem *********************************************************************
	echo Touching *.* ...
	cd \hyperjuke
	touch -r -e\hyperjuke\bin\hyperjuke.exe  *>>%LogFile%

	rem *********************************************************************
	rem *  Compress files
	rem *********************************************************************

	echo Zipping HyperJuke\* into %DestName% ...
	cd \hyperjuke 
	zip -r %DestName%  *>>%LogFile%

	rem *********************************************************************
	rem *  Uncompress the file into the test directory
	rem *********************************************************************
	mkdir %TestDir%>>%LogFile%
	unzip %DestName% -d %TestDir%>>%LogFile%


	rem *********************************************************************
	rem *  Displays the ending message
	rem *********************************************************************
	echo All done.
	c:
	cd %TestDir%
	dir

:Exit

