///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Disclist;

interface

uses
  MyFunc,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, Menus, DBCtrls, ExtCtrls,
  StdCtrls,
  Disc,MusicLst, Buttons;

type
  TformDiscTitles = class(TForm)
    panelButtom: TPanel;
    dbnavigator1: TDBNavigator;
    datasourceDiscTitle: TDataSource;
    dbgridDisc: TDBGrid;
    tableDisc: TTable;
    tableDiscDISC_ID: TStringField;
    tableDiscTITLE: TStringField;
    tableDiscTITLE2: TStringField;
    tableDiscPRODUCTION: TStringField;
    tableDiscCATEGORY: TStringField;
    tableDiscINDEX: TStringField;
    tableDiscTRACKS: TSmallintField;
    tableDiscFRAMES: TIntegerField;
    tableDiscTMP_TIME: TStringField;
    bitbtnDetailsOfDisc: TBitBtn;
    Panel1: TPanel;
    groupboxOrderBy: TGroupBox;
    radiobuttonDiscID: TRadioButton;
    radiobuttonCategory: TRadioButton;
    bitbtnAppend: TBitBtn;
    bitbtnClose: TBitBtn;
    tableCategory: TTable;
    tableCategoryCategory: TStringField;
    groupboxCategoryFileter: TGroupBox;
    comboboxCategory: TComboBox;
    bitbtnClear: TBitBtn;
    procedure radiobuttonDiscIDClick(Sender: TObject);
    procedure radiobuttonCategoryClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure tableDiscCalcFields(DataSet: TDataset);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure bitbtnAppendClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure bitbtnDetailsOfDiscClick(Sender: TObject);
    procedure bitbtnClearClick(Sender: TObject);
    procedure comboboxCategoryChange(Sender: TObject);
  private
    { Private declaration }
  public
    { Public declaration }
  end;

var
  formDiscTitles: TformDiscTitles;

implementation

uses Main, rpt_disctitle;

{$R *.DFM}

//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.radiobuttonDiscIDClick(Sender: TObject);
begin
     tableDisc.IndexName:='';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.radiobuttonCategoryClick(Sender: TObject);
begin
     tableDisc.IndexName:='USERS_INDEX';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.Button1Click(Sender: TObject);
var
     SelectedDiscID : string;
begin
  SelectedDiscID:=tableDisc.FieldByName('DISC_ID').AsString;
  with MusicLst.formMusicList do begin
    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=SelectedDiscID;
    queryMusic.Open;
    queryMusic.Active:=True;
    Show;
  end;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.tableDiscCalcFields(DataSet: TDataset);
begin
  with tableDisc do begin
    FieldByName('TMP_TIME').AsString
     :=MyFunc.FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.bitbtnAppendClick(Sender: TObject);
begin
  tableDisc.Append;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.FormActivate(Sender: TObject);
var
  CategoryStr : string;
  I           : word;
  NumOfFields : word;
begin
  NumOfFields:=tableCategory.RecordCount;
  if NumOfFields>0 then
    begin
      dbgridDisc.Columns[3].PickList.Clear;
      comboboxCategory.Items.Clear;
      tableCategory.First;
      for I:=0 to NumOfFields-1 do
        begin
          CategoryStr:=tableCategory.FieldByName('Category').AsString;
          dbgridDisc.Columns[3].PickList.Add(CategoryStr);
          comboboxCategory.Items.Add(CategoryStr);
          tableCategory.Next;
        end;
     end;
  // Refresh table because there is a possibility that another form revised
  // record.
  tableDisc.Refresh;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Main.DisplayStatus('Closing "Disc Title List" form...');
  if tableDisc.Modified then tableDisc.Post;
  Release;
  Main.DisplayStatus('Closed "Disc Title List" form.');
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.FormDeactivate(Sender: TObject);
begin
  if tableDisc.Modified then tableDisc.Post;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscTitles.bitbtnDetailsOfDiscClick(Sender: TObject);
var
  DiscID : string;
  DiscTitle : string;
begin
  DiscID:=tableDisc.FieldByName('DISC_ID').AsString;
  DiscTitle:=tableDisc.FieldByName('TITLE').AsString;
  Main.CreateOrShowDetailsOfDiscForm(DiscID);
end;

procedure TformDiscTitles.bitbtnClearClick(Sender: TObject);
var
  CategoryStr : string;
  I           : word;
  NumOfFields : word;
begin
  NumOfFields:=tableCategory.RecordCount;
  if NumOfFields>0 then
    begin
      comboboxCategory.Items.Clear;
      tableCategory.First;
      for I:=0 to NumOfFields-1 do
        begin
          CategoryStr:=tableCategory.FieldByName('Category').AsString;
          comboboxCategory.Items.Add(CategoryStr);
          tableCategory.Next;
        end;
     end;
  comboboxCategory.Update;
  tableDisc.Filtered:=False;
  tableDisc.Refresh;
end;







procedure TformDiscTitles.comboboxCategoryChange(Sender: TObject);
var
  FilterString : string;
begin
  FilterString:='Category='+''''+comboboxCategory.Text+'''';
  Main.DisplayStatus('Filter string '+FilterString);
  tableDisc.Filter:=FilterString;
  tableDisc.Filtered:=True;
  tableDisc.Refresh;
end;

end.
