///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit empty_c;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, StdCtrls, Buttons;

type
  TformEmptyCommonTables = class(TForm)
    labelMessage: TLabel;
    editVerify: TEdit;
    bitbtnDoIt: TBitBtn;
    bitbtnCancel: TBitBtn;
    tableTarget: TTable;
    labelVerifyString: TLabel;
    procedure bitbtnDoItClick(Sender: TObject);
    procedure bitbtnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
  procedure MyEmptyTable(TargetName: String);
  public
  end;

var
  formEmptyCommonTables: TformEmptyCommonTables;

implementation

uses Main;

{$R *.DFM}

const
  VerifyString = 'I know what I am doing.';


//*************************************************************************
//*
//*************************************************************************
procedure TformEmptyCommonTables.MyEmptyTable(TargetName: String);
begin
  With tableTarget do
    begin
      Active:=False;
      TableName:= TargetName;
      EmptyTable;
    end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformEmptyCommonTables.bitbtnDoItClick(Sender: TObject);
var
  I : Integer;
begin
  if editVerify.Text=VerifyString then
    begin
      for I:=0 to formMain.MDIChildCount-1 do
        begin
          formMain.MDIChildren[I].Close;
        end;
      MyEmptyTable('CATEGORY.DB');
      MyEmptyTable('DISC.DB');
      MyEmptyTable('LOCATION.DB');
      MyEmptyTable('MUSIC.DB');
      MyEmptyTable('UNIT.DB');
      MessageDlg('Emptied tables..', mtInformation, [mbOk], 0);
      formEmptyCommonTables.Release;
    end
    else
    begin
      MessageDlg('Verify text was mismatched.', mtInformation, [mbOk], 0);
    end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformEmptyCommonTables.bitbtnCancelClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//* onFormCloase event handler
//*************************************************************************
procedure TformEmptyCommonTables.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
  Main.DisplayStatus('Closed "Empty Common Tables" form...');
end;


//*************************************************************************
//* onFormCreate event handler
//*************************************************************************
procedure TformEmptyCommonTables.FormCreate(Sender: TObject);
begin
  labelVerifyString.Caption:=VerifyString;
end;

end.
