///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License for more details.                                     //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Main;

interface

uses
  ShellAPI, SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, StdCtrls,ExtCtrls, MPlayer, ComCtrls,
  Buttons, DBTables, DB;

type
  TformMain = class(TForm)
    menuMain: TMainMenu;
    menuFile: TMenuItem;
    menuExit: TMenuItem;
    menuHelp: TMenuItem;
    menuHint: TMenuItem;
    menuAbout: TMenuItem;
    menuQuickRecall: TMenuItem;
    menuWindow: TMenuItem;
    statusbar1: TStatusBar;
    menuArrangeIcons: TMenuItem;
    menuAdmin: TMenuItem;
    menuEmptyCommonTables: TMenuItem;
    menuEmptyPersonalTables: TMenuItem;
    menuArrangeRecords: TMenuItem;
    menuHelpContents: TMenuItem;
    menuHelpContentsJ: TMenuItem;
    menuDisplay: TMenuItem;
    menuDisplayCategory: TMenuItem;
    menuDisplayLocationList: TMenuItem;
    menuDisplayUnitList: TMenuItem;
    menuDisplayKeywordList: TMenuItem;
    menuDisplayDiscList: TMenuItem;
    menuDisplayDiscAndMusicList: TMenuItem;
    menuDisplayMusicList: TMenuItem;
    timerStatusDisplay: TTimer;
    menuDisplayPlayer: TMenuItem;
    queryDisc: TQuery;
    queryDiscDISC_ID: TStringField;
    queryDiscTITLE: TStringField;
    queryDiscTITLE2: TStringField;
    queryDiscPRODUCTION: TStringField;
    queryDiscCATEGORY: TStringField;
    queryDiscINDEX: TStringField;
    queryDiscTRACKS: TSmallintField;
    queryDiscFRAMES: TIntegerField;
    queryDiscTMP_TIME: TStringField;
    queryMusic: TQuery;
    queryMusicDISC_ID: TStringField;
    queryMusicTRACK1: TSmallintField;
    queryMusicTRACK2: TSmallintField;
    queryMusicTITLE: TStringField;
    queryMusicPLAYER: TStringField;
    queryMusicVERSIFIER: TStringField;
    queryMusicCOMPOSER: TStringField;
    queryMusicARRANGER: TStringField;
    queryMusicFRAMES: TIntegerField;
    queryMusicTMP_TIME: TStringField;
    queryMusicVOLUME: TSmallintField;
    menuFilePrintPreview: TMenuItem;
    menuPrintPreviewDiscTitleList: TMenuItem;
    menuDisplayFilter: TMenuItem;
    procedure menuExitClick(Sender: TObject);
    procedure menuContentsInEnglishClick(Sender: TObject);
    procedure menueContentsInJapaneseClick(Sender: TObject);
    procedure menuHintClick(Sender: TObject);
    procedure onFormCreate(Sender: TObject);
    procedure menuAboutClick(Sender: TObject);
    procedure menuQuickRecallClick(Sender: TObject);
//    procedure menuPlayerClick(Sender: TObject);
    procedure menuCascadeClick(Sender: TObject);
    procedure menuArrangeIconsClick(Sender: TObject);
    procedure menuEmptyCommonTablesClick(Sender: TObject);
    procedure menuEmptyPersonalTablesClick(Sender: TObject);
    procedure menuArrangeRecordsClick(Sender: TObject);
    procedure menuDisplayCategoryClick(Sender: TObject);
    procedure menuDisplayLocationListClick(Sender: TObject);
    procedure menuDisplayUnitListClick(Sender: TObject);
    procedure menuDisplayKeywordListClick(Sender: TObject);
    procedure menuDisplayDiscListClick(Sender: TObject);
    procedure menuDisplayDiscAndMusicListClick(Sender: TObject);
    procedure menuDisplayMusicListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure timerStatusDisplayTimer(Sender: TObject);
    procedure menuDisplayPlayerClick(Sender: TObject);
    procedure menuPrintPreviewDiscTitleListClick(Sender: TObject);
    procedure menuDisplayFilterClick(Sender: TObject);
  private
  public
end;

var
  formMain: TformMain;

procedure CreateOrShowDetailsOfDiscForm(DiscID:string);
procedure CreateOrShowDetailsOfMusicForm(DiscID: string;Track1,Track2: integer);
procedure CreateOrShowFilterForm;
procedure CreateOrShowMusicListForm;
procedure CreateOrShowProgramPlayerForm;
procedure DisplayStatus(Mess : String);

implementation

uses MyFunc,Empty_C, Empty_P, arrange, category, MusicLst, About, Autoload,
  Location, Unitlist, Keyword, Disclist, Discmus, Disc, Music,
  Filter, progplayer, rpt_disctitle;

{$R *.DFM}



//*************************************************************************
//* Create of show "Details of Disc" form
//*************************************************************************
procedure CreateOrShowDetailsOfDiscForm(DiscID: string);
var
     CaptionString  : string;
procedure _CreateForm;
begin
  Application.CreateForm(TformDetailsOfDisc, formDetailsOfDisc);
  with formDetailsOfDisc do begin
    Caption:=CaptionString;
    queryDisc.Active:=False;
    queryDisc.Prepare;
    queryDisc.Close;
    queryDisc.Params[0].AsString:=DiscID;
    queryDisc.Open;
    queryDisc.Active:=True;

    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=DiscID;
    queryMusic.Open;
    queryMusic.Active:=True;

    queryLocation.Active:=False;
    queryLocation.Prepare;
    queryLocation.Close;
    queryLocation.Params[0].AsString:=DiscID;
    queryLocation.Open;
    queryLocation.Active:=True;
  end;
end;

var
  Title : string;
  Title2 : string;
  FormNumber : integer;
begin
  with formMain.queryDisc do
    begin
      Active:=False;
      Prepare;
      Close;
      Params[0].AsString:=DiscID;
      Open;
      Active:=True;
    end;
  Title:=formMain.queryDisc.FieldByName('TITLE').AsString;
  Title2:=formMain.queryDisc.FieldByName('TITLE2').AsString;
  CaptionString:='Details of Disc - ['+ Title+'/'+ Title2+']';

  FormNumber:=GetFormNumberByCaption(CaptionString);
  if FormNumber>0
    then
      begin
        Screen.Forms[FormNumber].Show;
        Screen.Forms[FormNumber].WindowState:=wsNormal;
      end
    else
      begin
        _CreateForm;
      end;
end;



//*************************************************************************
//* Create or show "Details of Music" form
//*************************************************************************
procedure CreateOrShowDetailsOfMusicForm(DiscID: string;
  Track1,Track2: integer);
var
     CaptionString  : string;

procedure _CreateForm;
begin
  Application.CreateForm(TformDetailsOfMusic, formDetailsOfMusic);
  with formDetailsOfMusic do begin
    Caption:=CaptionString;
    queryDisc.Active:=False;
    queryDisc.Prepare;
    queryDisc.Close;
    queryDisc.Params[0].AsString:=DiscID;
    queryDisc.Open;
    queryDisc.Active:=True;

    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=DiscID;
    queryMusic.Params[1].AsInteger:=Track1;
    queryMusic.Params[2].AsInteger:=Track2;
    queryMusic.Open;
    queryMusic.Active:=True;
  end;
end;

var
  FormNumber : integer;
  Player : string;
  Title  : string;
begin
  with formMain.queryMusic do
    begin
      Active:=False;
      Prepare;
      Close;
      Params[0].AsString:=DiscID;
      Params[1].AsInteger:=Track1;
      Params[2].AsInteger:=Track2;
      Open;
      Active:=True;
    end;
  Title:=formMain.queryMusic.FieldByName('TITLE').AsString;
  Player:=formMain.queryMusic.FieldByName('PLAYER').AsString;
  CaptionString:='Details of Music - ['+ Title + '/' + Player +']';

  FormNumber:=GetFormNumberByCaption(CaptionString);
  if FormNumber>0
    then
      begin
        Screen.Forms[FormNumber].Show;
        Screen.Forms[FormNumber].WindowState:=wsNormal;
      end
    else
      begin
        _CreateForm;
      end;
end;

procedure CreateOrShowFilterForm;
begin
  if IsFormCreated('formFilter')
    then
      begin
        formFilter.Show;
        formFilter.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Filter"...');
        Application.CreateForm(TformFilter, formFilter);
      end;
end;

procedure CreateOrShowMusicListForm;
begin
  if IsFormCreated('formMusicList')
    then
      begin
        formMusicList.Show;
        formMusicList.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Music List"...');
        Application.CreateForm(TformMusicList, formMusicList);
      end;
end;

procedure CreateOrShowProgramPlayerForm;
begin
    if IsFormCreated('formProgPlayer')
    then
      begin
        formProgPlayer.Show;
        formProgPlayer.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Program Player"...');
        Application.CreateForm(TformProgPlayer, formProgPlayer);
        formProgPlayer.Show;
      end;
end;

//*************************************************************************
//* Displays Status string
//*************************************************************************
procedure DisplayStatus(Mess : String);
begin
  with formMain.timerStatusDisplay do
    begin
      if Enabled=True
        then Enabled:=False;
      Enabled:=True;
    end;

  formMain.statusbar1.Panels[0].text:=Mess;
  formMain.statusbar1.update;
end;


//*************************************************************************
//* Displays the result when help file was opened
//*************************************************************************
procedure DisplayResult(Code: word; FileName:string);
var
     CodeStr        : string;
begin
     if Code<32 then begin
          str(Code, CodeStr);
          MessageDlg('Could not open "'+FileName+'".'+chr($0D)+
               'Return Code was '+CodeStr+' .', mtWarning, [mbOK],0);
     end;
end;


//*************************************************************************
//* Closes the form
//*************************************************************************
procedure TformMain.menuExitClick(Sender: TObject);
begin
  formMain.Close;
end;


//*************************************************************************
//* Opens help contents in English
//*************************************************************************
procedure TformMain.menuContentsInEnglishClick(Sender: TObject);
const
     FileName = '..\doc\html\index.html';
var
     Ans       : word;
begin
  DisplayStatus('Opening "'+FileName+'"...');
  Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
  DisplayResult(Ans, FileName);
end;


//*************************************************************************
//* Opens help contents in Japanese
//*************************************************************************
procedure TformMain.menueContentsInJapaneseClick(Sender: TObject);
const
     FileName = '..\doc\html\index-j.html';
var
     Ans       : word;
begin
  DisplayStatus('Opening "'+FileName+'"...');
  Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
  DisplayResult(Ans, FileName);
end;


//*************************************************************************
//* Alternates status of the showhint switch
//*************************************************************************
procedure TformMain.menuHintClick(Sender: TObject);
begin
  case menuHint.Checked of
    True: begin
      menuHint.Checked:=False;
      menuHint.Caption:='Hint (Now Disabled)(&I)';
      Application.ShowHint:=False;
      DisplayStatus('Disabled hint message.');
    end;
    False: begin
      menuHint.Checked:=True;
      menuHint.Caption:='Hint (Now Enabled)(&I)';
      Application.ShowHint:=True;
      DisplayStatus('Enabled hint message.');
    end;
  end;
end;


//*************************************************************************
//* Executes when the form creates
//*************************************************************************
procedure TformMain.onFormCreate(Sender: TObject);
begin
  DisplayStatus('Welcome to the Hyper Juke');
  Width:=800;
  Height:=600;
end;


//*************************************************************************
//* Opens the About form
//*************************************************************************
procedure TformMain.menuAboutClick(Sender: TObject);
begin
  DisplayStatus('Opening "About"...');
  Application.CreateForm(TformAbout, formAbout);
  formAbout.ShowModal;
end;


//*************************************************************************
//* Opens the Quick Recall form
//*************************************************************************
procedure TformMain.menuQuickRecallClick(Sender: TObject);
begin
  if IsFormCreated('formQuickRecall')
    then
      begin
        formQuickRecall.Show;
        formQuickRecall.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Quick Recall"...');
        Application.CreateForm(TformQuickRecall, formQuickRecall);
        formQuickRecall.Show;
      end;
end;


//*************************************************************************
//* Opens the Player form
//*************************************************************************
(*
procedure TformMain.menuPlayerClick(Sender: TObject);
begin
  if IsFormCreated('formPlayer')
    then
      begin
        formPlayer.Show;
        formPlayer.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Player"...');
        Application.CreateForm(TformPlayer, formPlayer);
        formPlayer.Show;
      end;
end;
*)

//*************************************************************************
//* Cascades MDI child forms
//*************************************************************************
procedure TformMain.menuCascadeClick(Sender: TObject);
begin
  Cascade;
  DisplayStatus('Cascaded forms.');
end;


//*************************************************************************
//* Arranges MDI children icons
//*************************************************************************
procedure TformMain.menuArrangeIconsClick(Sender: TObject);
begin
  ArrangeIcons;
  DisplayStatus('Arranged icons.');
end;


//*************************************************************************
//* Emptys tables commonly used by the all users
//*************************************************************************
procedure TformMain.menuEmptyCommonTablesClick(Sender: TObject);
begin
  DisplayStatus('Opening "Empty Common Tables"...');
  Application.CreateForm(TformEmptyCommonTables, formEmptyCommonTables);
  formEmptyCommonTables.ShowModal;
end;


//*************************************************************************
//* Emptys tables personaly used
//*************************************************************************
procedure TformMain.menuEmptyPersonalTablesClick(Sender: TObject);
begin
  DisplayStatus('Opening "Empty Personal Tables"...');
  Application.CreateForm(TformEmptyPersonalTables, formEmptyPersonalTables);
  formEmptyPersonalTables.ShowModal;
end;


//*************************************************************************
//* Opens the Arrange Records form
//*************************************************************************
procedure TformMain.menuArrangeRecordsClick(Sender: TObject);
begin
  DisplayStatus('Opening "Arrange Personal Tables"...');
  Application.CreateForm(TformArrangePersonalTable, formArrangePersonalTable);
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayCategoryClick(Sender: TObject);
begin
  if IsFormCreated('formCategory')
    then
      begin
        formCategory.Show;
        formCategory.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Category List"...');
        Application.CreateForm(TformCategory, formCategory);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayLocationListClick(Sender: TObject);
begin
  if IsFormCreated('formLocationList')
    then
      begin
        formLocationList.Show;
        formLocationList.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Disc Location List"...');
        Application.CreateForm(TformLocationList, formLocationList);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayUnitListClick(Sender: TObject);
begin
  if IsFormCreated('formUnitTitles')
    then
      begin
        formUnitTitles.Show;
        formUnitTitles.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Unit List"...');
        Application.CreateForm(TformUnitTitles, formUnitTitles);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayKeywordListClick(Sender: TObject);
begin
  if IsFormCreated('formKeyword')
    then
      begin
        formKeyword.Show;
        formKeyword.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Keyword List"...');
        Application.CreateForm(TformKeyword, formKeyword);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayDiscListClick(Sender: TObject);
begin
  if IsFormCreated('formDiscTitles')
    then
      begin
        formDiscTitles.Show;
        formDiscTitles.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Disc List"...');
        Application.CreateForm(TformDiscTitles, formDiscTitles);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayDiscAndMusicListClick(Sender: TObject);
begin
  if IsFormCreated('formDiscAndMusicTitles')
    then
      begin
        formDiscAndMusicTitles.Show;
        formDiscAndMusicTitles.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Disc & Music List"...');
        Application.CreateForm(TformDiscAndMusicTitles, formDiscAndMusicTitles);
      end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.menuDisplayMusicListClick(Sender: TObject);
begin
  CreateOrShowMusicListForm;
end;


//*************************************************************************
//* Executes when form closes
//*************************************************************************
procedure TformMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I   : word;
begin
  if formMain.MDIChildCount=0 then exit;
  for I:=0 to formMain.MDIChildCount-1 do
    begin
       formMain.MDIChildren[I].Close;
    end;
end;

procedure TformMain.timerStatusDisplayTimer(Sender: TObject);
begin
  timerStatusDisplay.Enabled:=False;
  formMain.statusbar1.Panels[0].text:='';
  formMain.statusbar1.update;
end;

procedure TformMain.menuDisplayPlayerClick(Sender: TObject);
begin
  if IsFormCreated('formProgPlayer')
    then
      begin
        formProgPlayer.Show;
        formProgPlayer.WindowState:=wsNormal;
      end
    else
      begin
        DisplayStatus('Opening "Program Player"...');
        Application.CreateForm(TformProgPlayer, formProgPlayer);
      end;
end;

procedure TformMain.menuPrintPreviewDiscTitleListClick(Sender: TObject);
begin
  if not(IsFormCreated('reportDiscTitleList'))
    then
      begin
        DisplayStatus('Opening "Disc Title List Report"...');
        Application.CreateForm(TreportDiscTitleList, reportDiscTitleList);
      end;
  reportDiscTitleList.quickreportDiscTitleList.Preview;
end;

procedure TformMain.menuDisplayFilterClick(Sender: TObject);
begin
  CreateOrShowFilterForm;
end;

end.
