///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Musiclst;

interface

uses
  MyFunc,Filter,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, StdCtrls, DBCtrls, ExtCtrls,
  Buttons, ComCtrls;

type
  TformMusicList = class(TForm)
    panelButtom: TPanel;
    datasourceMusic: TDataSource;
    dbgridMusic: TDBGrid;
    bitbtnClose: TBitBtn;
    bitbtnDetails: TBitBtn;
    queryMusic: TQuery;
    labelNoOfMusics: TLabel;
    labelNoOfMusicsValue: TLabel;
    labelTotalTime: TLabel;
    labelTotalTimeValue: TLabel;
    bitbtnFilter: TBitBtn;
    queryMusicTMP_TIME: TStringField;
    queryMusicUNIT_ID: TStringField;
    queryMusicSLOT_ID: TStringField;
    queryMusicTRACK1: TSmallintField;
    queryMusicTRACK2: TSmallintField;
    queryMusicTITLE: TStringField;
    queryMusicPLAYER: TStringField;
    queryMusicCOMPOSER: TStringField;
    queryMusicFRAMES: TIntegerField;
    queryMusicKEYWORD: TStringField;
    queryMusicTASTE: TSmallintField;
    queryMusicDISC_ID: TStringField;
    queryMusicCOUNTER: TIntegerField;
    bitbtnPlayer: TBitBtn;
    tableProg: TTable;
    procedure queryMusicCalcFields(DataSet: TDataset);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure bitbtnDetailsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bitbtnFilterClick(Sender: TObject);
    procedure queryMusicAfterOpen(DataSet: TDataSet);
    procedure bitbtnPlayerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  formMusicList: TformMusicList;

implementation

uses Main,Music, progplayer;

{$R *.DFM}


//*************************************************************************
//* Displays TIME converted from FRAMES
//*************************************************************************
procedure TformMusicList.queryMusicCalcFields(DataSet: TDataset);
begin
  with queryMusic do begin
    FieldByName('TMP_TIME').AsString
      := MyFunc.FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//*************************************************************************
//* Closes the form
//*************************************************************************
procedure TformMusicList.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//* Opens "Details of Music" form
//*************************************************************************
procedure TformMusicList.bitbtnDetailsClick(Sender: TObject);
var
  DiscID : string;
  //MusicTitle : string;
  Track1 : Integer;
  Track2 : Integer;
begin
  DiscID:=queryMusic.FieldByName('DISC_ID').AsString;
  Track1:=queryMusic.FieldByName('TRACK1').AsInteger;
  Track2:=queryMusic.FieldByName('TRACK2').AsInteger;
  //MusicTitle:=queryMusic.FieldByName('Title').AsString;
  Main.CreateOrShowDetailsOfMusicForm(DiscID,Track1,Track2);
end;


//*************************************************************************
//* Refreshs the form
//*************************************************************************
procedure TformMusicList.FormActivate(Sender: TObject);
begin
  queryMusic.Refresh;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMusicList.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Main.DisplayStatus('Closing "Music Title List" form...');
  Release;
  Main.DisplayStatus('Closed "Music Title List" form.');
end;

procedure TformMusicList.bitbtnFilterClick(Sender: TObject);
begin
  Main.CreateOrShowFilterForm;
end;

procedure TformMusicList.queryMusicAfterOpen(DataSet: TDataSet);
var
  I           : integer;
  NoOfMusics : integer;
  TotalFrames : longint;
begin
  NoOfMusics:=queryMusic.RecordCount;
  labelNoOfMusicsValue.Caption:=IntToStr(NoOfMusics);
  TotalFrames:=0;
  if NoOfMusics>0
    then
      begin
        queryMusic.First;
        for I:=1 to NoOfMusics do
          begin
            TotalFrames:=TotalFrames+queryMusic.FieldByName('FRAMES').AsInteger;
          end;
        queryMusic.First;
      end;
  labelTotalTimeValue.Caption:=FrameToTime(TotalFrames);
  labelNoOfMusicsValue.Update;
  labelTotalTimeValue.Update;
end;

procedure TformMusicList.bitbtnPlayerClick(Sender: TObject);
//*************************************************************************
//*
//*************************************************************************
var
  //MessageStr  : String;
  No   : Integer;
begin
  {queryMusic.Last;}
  if queryMusic.RecordCount=0 then begin
    MessageDlg('There is no record.', mtWarning, [mbOk], 0);
    Exit;
  end
  else
   begin
    No:=1;
    queryMusic.First;
    DisplayStatus('Deactivate tableProg');
    tableProg.Active:=False;
    DisplayStatus('Erasing all records in "tableProg"...');
    tableProg.EmptyTable;
    tableProg.Active:=True;
    repeat
      tableProg.Append;
      tableProg.FieldByName('PAGE').AsString:='A';
      tableProg.FieldByName('NO').AsInteger:=No;
      tableProg.FieldByName('UNIT_ID').AsString:=queryMusic.FieldByName('UNIT_ID').AsString;
      tableProg.FieldByName('SLOT_ID').AsString:=queryMusic.FieldByName('SLOT_ID').AsString;
      tableProg.FieldByName('DISC_ID').AsString
        :=queryMusic.FieldByName('DISC_ID').AsString;
      tableProg.FieldByName('TRACK1').AsInteger
        :=queryMusic.FieldByName('TRACK1').AsInteger;
      tableProg.FieldByName('TRACK2').AsInteger
        :=queryMusic.FieldByName('TRACK2').AsInteger;
      tableProg.Post;
      queryMusic.Next;
      inc(No);
    until queryMusic.Eof;
    CreateOrShowProgramPlayerForm;
    formProgPlayer.DisplayMusicTime;
    formProgPlayer.tableProg.Refresh;
  end;
end;

procedure TformMusicList.FormCreate(Sender: TObject);
begin
  tableProg.Active:=False;
  tableProg.Databasename:=ExtractFilePath(ParamStr(0))+'WORK';
  tableProg.Active:=True;
end;

end.
