///////////////////////////////////////////////////////////////////////////
//                       About unit for the Delphi.                      //
//                Copyright (C) 1995, 1997 Fumio Kawamata                //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************

unit about;

interface


uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls;

const
  ProgramComment ='Audio CD Database with Media Player';
  ProgramName = 'Hyper Juke';
  ProgramVersion = 'Version 4.02';
  ProgramCopyright = 'Copyright(C) 1990,1997 Fumio Kawamata';

type
  TformAbout = class(TForm)
    bitbtnAuthor        : TBitBtn;
    bitbtnClose         : TBitBtn;
    bitbtnGNUGPL        : TBitBtn;
    labelProgCopyright: TLabel;
    labelProgNameUpper  : TLabel;
    labelDistribute     : TLabel;
    labelProgComment    : TLabel;
    labelProgNameLower  : TLabel;
    labelProgVersion: TLabel;
    procedure bitbtnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bitbtnGNUGPLClick(Sender: TObject);
    procedure bitbtnAuthorClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
  public
  end;

var
  formAbout: TformAbout;

implementation

uses
  Main,author, GNUGPL;

{$R *.DFM}


//*************************************************************************
//* Close myself
//*************************************************************************
procedure TformAbout.bitbtnCloseClick(Sender: TObject);
begin
  formAbout.Close;
end;


//*************************************************************************
//* Sets captions and the image
//*************************************************************************
procedure TformAbout.FormCreate(Sender: TObject);
begin
  labelProgComment.Caption:=About.ProgramComment;
  labelProgNameUpper.Caption:=About.ProgramName;
  labelProgNameLower.Caption:=About.ProgramName;
  labelProgVersion.Caption:=About.ProgramVersion;
  labelProgCopyright.Caption:=About.ProgramCopyright;
  Main.DisplayStatus('Opened "'+formAbout.Caption+'".');
end;


//*************************************************************************
//* Opens GNU GPL document form
//*************************************************************************
procedure TformAbout.bitbtnGNUGPLClick(Sender: TObject);
begin
  Application.CreateForm(TformGNUGPL, formGNUGPL);
  formGNUGPL.ShowModal;
end;

//*************************************************************************
//* Opens about the author form
//*************************************************************************
procedure TformAbout.bitbtnAuthorClick(Sender: TObject);
begin
  Application.CreateForm(TformAuthor, formAuthor);
  formAuthor.ShowModal;
end;


//*************************************************************************
//* onClose event
//*************************************************************************
procedure TformAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Main.DisplayStatus('Closing "'+Caption+'"...');
  Release;
  Main.DisplayStatus('Closed "'+Caption+'".');
end;

//*************************************************************************
//* onActivate event
//*************************************************************************
procedure TformAbout.FormActivate(Sender: TObject);
begin
  Main.DisplayStatus('Activated "'+Caption+'".');
end;

end.
