///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit arrange;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, DB, DBTables;

type
  TformArrangePersonalTable = class(TForm)
    checkboxAppend: TCheckBox;
    checkboxRemove: TCheckBox;
    bitbtnDoIt: TBitBtn;
    bitbtnCancel: TBitBtn;
    tableMusic: TTable;
    tableTaste: TTable;
    progressbarAppend: TProgressBar;
    progressbarRemove: TProgressBar;
    bitbtnOK: TBitBtn;
    labelStatus: TLabel;
    procedure FormDeactivate(Sender: TObject);
    procedure bitbtnCancelClick(Sender: TObject);
    procedure bitbtnDoItClick(Sender: TObject);
    procedure bitbtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

var
  formArrangePersonalTable: TformArrangePersonalTable;

implementation

uses Main;

{$R *.DFM}

//*************************************************************************
//* Closes form
//*************************************************************************
procedure TformArrangePersonalTable.FormDeactivate(Sender: TObject);
begin
  Release;
end;


//*************************************************************************
//* Closes form
//*************************************************************************
procedure TformArrangePersonalTable.bitbtnCancelClick(Sender: TObject);
begin
  Release;
end;


//*************************************************************************
//* Appends/Removes records in the personal taste table
//*************************************************************************
procedure TformArrangePersonalTable.bitbtnDoItClick(Sender: TObject);
var
  I             : word;
  NumOfRecords  : word;

procedure Append_;
var
  I : word;
  ActionStr : String;
begin
  progressbarAppend.Min:=1;
  progressbarAppend.Max:=NumOfRecords;
  tableMusic.First;
  for I:=1 to NumOfRecords do
    begin
      progressbarAppend.Position:=I;
      if tableTaste.FindKey([ tableMusic.Fields[0], tableMusic.Fields[1],
        tableMusic.Fields[2] ]) then
        begin
          ActionStr:='Skipped ';
        end
        else
        begin
          ActionStr:='Appended';
          tableTaste.Append;
          tableTaste.FieldByName('DISC_ID').AsString
            :=tableMusic.FieldByName('DISC_ID').AsString;
          tableTaste.FieldByName('TRACK1').AsInteger
            :=tableMusic.FieldByName('TRACK1').AsInteger;
          tableTaste.FieldByName('TRACK2').AsInteger
            :=tableMusic.FieldByName('TRACK2').AsInteger;
          tableTaste.FieldByName('KEYWORD').AsString:='';
          tableTaste.FieldByName('TASTE').AsInteger:=1;
          tableTaste.FieldByName('COUNTER').AsInteger:=0;
          tableTaste.Post;
        end;
      labelStatus.Caption:=ActionStr+'  '+tableMusic.Fields[0].AsString;
      labelStatus.Update;
      tableMusic.Next;
    end;
end;

procedure Remove_;
var
  ActionStr : String;
  I : word;
begin
  progressbarRemove.Min:=1;
  progressbarRemove.Max:=NumOfRecords;
  tableTaste.First;
  for I:=1 to NumOfRecords do
    begin
      progressbarRemove.Position:=I;
      if tableMusic.FindKey([ tableTaste.Fields[0], tableTaste.Fields[1],
        tableTaste.Fields[2] ]) then
        begin
          ActionStr:='Skipped ';
        end
        else
        begin
          ActionStr:='Removed';
          tableTaste.Delete;
        end;
      labelStatus.Caption:=ActionStr+'  '+tableTaste.Fields[0].AsString;
      labelStatus.Update;
      tableTaste.Next;
    end;
end;

begin
  bitbtnDoIt.Enabled:=False;
  bitbtnDoIt.Visible:=False;
  bitbtnCancel.Enabled:=False;
  bitbtnCancel.Visible:=False;
  if checkboxAppend.Checked or checkboxRemove.Checked then
    begin
     for I:=0 to formMain.MDIChildCount-1 do
      begin
        with formMain.MDIChildren[I] do
          begin
            if Name<>'formArrangePersonalTable' then Close;
          end;
      end;
    end;
  if checkboxAppend.Checked then
    begin  // Appends new records
      NumOfRecords:=tableMusic.RecordCount;
      if NumOfRecords>0 then Append_;
    end;
  if checkboxRemove.Checked then
    begin // Removes garbage records
      NumOfRecords:=tableTaste.RecordCount;
      if NumOfRecords>0 then Remove_;
    end;
  labelStatus.Caption:='Finished';
  bitbtnOK.Enabled:=True;
  bitbtnOK.Visible:=True;
end;


//*************************************************************************
//* Resets statuses
//*************************************************************************
procedure TformArrangePersonalTable.bitbtnOKClick(Sender: TObject);
begin
  Release;
{
  checkboxAppend.Checked:=True;
  checkboxRemove.Checked:=False;
  progressbarAppend.Position:=0;
  progressbarRemove.Position:=0;
  labelStatus.Caption:='';
  bitbtnDoIt.Enabled:=True;
  bitbtnDoIt.Visible:=True;
  bitbtnOK.Enabled:=False;
  bitbtnOK.Visible:=False;
  bitbtnCancel.Enabled:=True;
  bitbtnCancel.Visible:=True;
  Update;
  Hide;
}
end;


//******************************************************************************
//* onFormCreate event handler
//******************************************************************************
procedure TformArrangePersonalTable.FormCreate(Sender: TObject);
begin
  //Hide;
  //WindowState:=wsMinimized;
end;


//******************************************************************************
//* onFormClose event handler
//******************************************************************************
procedure TformArrangePersonalTable.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Release;
  Main.DisplayStatus('Closed "Arrange" form.');
end;

end.
