///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Discmus;

interface

uses
  Disc, Music, MyFunc,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, Menus, DBCtrls, ExtCtrls,
  StdCtrls, Buttons;

type
  TformDiscAndMusicTitles = class(TForm)
    panelBottom: TPanel;
    dbnavigatorMusic: TDBNavigator;
    tableDisc: TTable;
    panelMiddle: TPanel;
    datasourceDisc: TDataSource;
    tableMusic: TTable;
    datasourceMusic: TDataSource;
    dbgridMusic: TDBGrid;
    panelTop: TPanel;
    dbnavigatorDisc: TDBNavigator;
    groupbox1: TGroupBox;
    radiobuttonDisc: TRadioButton;
    radiobuttonCategory: TRadioButton;
    labelDiscList: TLabel;
    labelMusicList: TLabel;
    dbgridDisc: TDBGrid;
    tableDiscDISC_ID: TStringField;
    tableDiscTITLE: TStringField;
    tableDiscTITLE2: TStringField;
    tableDiscPRODUCTION: TStringField;
    tableDiscCATEGORY: TStringField;
    tableDiscINDEX: TStringField;
    tableDiscTRACKS: TSmallintField;
    tableDiscFRAMES: TIntegerField;
    tableMusicDISC_ID: TStringField;
    tableMusicTRACK1: TSmallintField;
    tableMusicTRACK2: TSmallintField;
    tableMusicTITLE: TStringField;
    tableMusicPLAYER: TStringField;
    tableMusicVERSIFIER: TStringField;
    tableMusicCOMPOSER: TStringField;
    tableMusicARRANGER: TStringField;
    tableMusicFRAMES: TIntegerField;
    tableMusicVOLUME: TSmallintField;
    tableDiscTMP_TIME: TStringField;
    tableMusicTMP_TIME: TStringField;
    bitbtnMusic: TBitBtn;
    bitbtnDisc: TBitBtn;
    bitbtnClose: TBitBtn;
    procedure checkboxDiscClick(Sender: TObject);
    procedure checkboxCategoryClick(Sender: TObject);
    procedure radiobuttonDiscClick(Sender: TObject);
    procedure radiobuttonCategoryClick(Sender: TObject);
    procedure tableMusicCalcFields(DataSet: TDataset);
    procedure tableDiscCalcFields(DataSet: TDataset);
    procedure bitbtnDetailsOfDiscClick(Sender: TObject);
    procedure bitbtnDetailsOfMusicClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declaration }
  public
    { Public declaration }
  end;

var
  formDiscAndMusicTitles: TformDiscAndMusicTitles;

implementation

{$R *.DFM}

uses Main;

//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.checkboxDiscClick(Sender: TObject);
begin
     tableDisc.IndexName:='';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.checkboxCategoryClick(Sender: TObject);
begin
     tableDisc.IndexName:='USERS_INDEX';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.radiobuttonDiscClick(Sender: TObject);
begin
     tableDisc.IndexName:='';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.radiobuttonCategoryClick(Sender: TObject);
begin
     tableDisc.IndexName:='USERS_INDEX';
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.bitbtnDetailsOfDiscClick(Sender: TObject);
var
  DiscID : string;
  //DiscTitle : string;
begin
  DiscID:=tableDisc.FieldByName('DISC_ID').AsString;
  //DiscTitle:=tableDisc.FieldByName('TITLE').AsString;
  Main.CreateOrShowDetailsOfDiscForm(DiscID);
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.bitbtnDetailsOfMusicClick(
  Sender: TObject);
var
     DiscID : string;
     //MusicTitle : string;
     Track1 : Integer;
     Track2 : Integer;
begin
  DiscID:=tableMusic.FieldByName('DISC_ID').AsString;
  Track1:=tableMusic.FieldByName('TRACK1').AsInteger;
  Track2:=tableMusic.FieldByName('TRACK2').AsInteger;
  //MusicTitle:=tableMusic.FieldByName('Title').AsString;
  Main.CreateOrShowDetailsOfMusicForm(DiscID, Track1, Track2);
end;


//******************************************************************************
//* Handles the onCalcField event of the tableMusic object
//******************************************************************************
procedure TformDiscAndMusicTitles.tableMusicCalcFields(DataSet: TDataset);
begin
  with tableMusic do begin
    FieldByName('TMP_TIME').AsString
    :=MyFunc.FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//******************************************************************************
//* Handles the onCalcField event of the tableDisc object
//******************************************************************************
procedure TformDiscAndMusicTitles.tableDiscCalcFields(DataSet: TDataset);
begin
  with tableDisc do begin
    FieldByName('TMP_TIME').AsString
    :=FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;



//******************************************************************************
//* Handles the onActivate event of the formDiscAndMusicTitles object
//******************************************************************************
procedure TformDiscAndMusicTitles.FormActivate(Sender: TObject);
begin
  // Refreshs tableDisc and tableMusic because there is a possibility that
  // the other forms changed the record of them.
  tableDisc.Refresh;
  tableMusic.Refresh;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Main.DisplayStatus('Closing "Disc & Music Title List" form...');
  if tableDisc.Modified then tableDisc.Post;
  if tableMusic.Modified then tableMusic.Post;
  Release;
  Main.DisplayStatus('Closed "Disc & Music Title List" form.');
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDiscAndMusicTitles.FormDeactivate(Sender: TObject);
begin
  if tableDisc.Modified then tableDisc.Post;
  if tableMusic.Modified then tableMusic.Post;
end;

end.
