///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Music;

interface

uses
  Keyword, MyFunc,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask, DBCtrls, DB, DBTables, ExtCtrls, Grids,
  DBGrids, DBLookup, Buttons;

type
  TformDetailsOfMusic = class(TForm)
    bitbtnEditKeywordList   : TBitBtn;
    bitbtnAddToKeyword      : TBitBtn;
    datasourceDisc          : TDataSource;
    dbtextCounter           : TDBText;
    labelCounter            : TLabel;
    datasourceKeyword       : TDataSource;
    dblookuplistKeyword     : TDBLookupList;
    panelBorder2            : TPanel;
    dbnavigatorUserData     : TDBNavigator;
    labelKeyword            : TLabel;
    dbeditKeyword           : TDBEdit;
    labelTaste              : TLabel;
    dbeditTaste             : TDBEdit;
    datasourceUserData      : TDataSource;
    dbnavigatorMusic        : TDBNavigator;
    dbtextTrack2            : TDBText;
    labelHifun: TLabel;
    dbtextTrack1            : TDBText;
    labelTrack: TLabel;
    dbtextDiscTitle2        : TDBText;
    dbtextDiscTitle         : TDBText;
    dbtextTime              : TDBText;
    labelVolume             : TLabel;
    dbeditVolume            : TDBEdit;
    labelTime               : TLabel;
    labelArranger           : TLabel;
    labelComposer           : TLabel;
    labelVersifier          : TLabel;
    labelPlayer             : TLabel;
    dbeditComposer          : TDBEdit;
    dbeditVersifier         : TDBEdit;
    queryMusicTMP_TIME      : TStringField;
    queryMusicVOLUME        : TSmallintField;
    queryMusicFRAMES        : TIntegerField;
    queryMusicARRANGER      : TStringField;
    queryMusicCOMPOSER      : TStringField;
    queryMusicVERSIFIER     : TStringField;
    queryMusicPLAYER        : TStringField;
    queryMusicTITLE         : TStringField;
    queryMusicTRACK2        : TSmallintField;
    queryMusicTRACK1        : TSmallintField;
    queryMusicDISC_ID       : TStringField;
    dbeditArranger          : TDBEdit;
    dbeditPlayer            : TDBEdit;
    labelTitle              : TLabel;
    dbeditTitle             : TDBEdit;
    datasourceMusic         : TDataSource;
    labelDiscTitle2         : TLabel;
    labelDiscTitle          : TLabel;
    labelDiscID             : TLabel;
    dbtextDiscID            : TDBText;
    queryDisc               : TQuery;
    queryMusic              : TQuery;
    queryUserData           : TQuery;
    tableKeyword            : TTable;
    bitbtnClose: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure queryMusicCalcFields(DataSet: TDataset);
    procedure bitbtnEditKeywordListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure bitbtnAddToKeywordClick(Sender: TObject);
  private
  public
  end;

var
  formDetailsOfMusic: TformDetailsOfMusic;

implementation

{$R *.DFM}
uses Main;

//******************************************************************************
//* Executes when form create event occurs
//******************************************************************************
procedure TformDetailsOfMusic.FormCreate(Sender: TObject);
begin
  Width:=750;
  Height:=450;
end;


//******************************************************************************
//* Opens keyword list form
//******************************************************************************
procedure TformDetailsOfMusic.bitbtnEditKeywordListClick(Sender: TObject);
begin
  if IsFormCreated('formKeyword')
    then
      begin
        formKeyword.Show;
        formKeyword.WindowState:=wsNormal;
      end
    else
      begin
        Application.CreateForm(TformKeyword, formKeyword);
      end;
end;


//******************************************************************************
//* Converts frame format to time format
//******************************************************************************
procedure TformDetailsOfMusic.queryMusicCalcFields(DataSet: TDataset);
begin
  with queryMusic do begin
    FieldByName('TMP_TIME').AsString
      :=FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//******************************************************************************
//* Closes myself
//******************************************************************************
procedure TformDetailsOfMusic.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//******************************************************************************
//*
//******************************************************************************
procedure TformDetailsOfMusic.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  FormCaption: string;
begin
  FormCaption:=Caption;
  Main.DisplayStatus('Closing '+FormCaption+'...');
  if queryMusic.Modified then queryMusic.Post;
  if queryUserData.Modified then queryUserData.Post;
  Release;
  Main.DisplayStatus('Closed '+FormCaption+'.');
end;


//******************************************************************************
//* Refreshs query and table objects
//******************************************************************************
procedure TformDetailsOfMusic.FormActivate(Sender: TObject);
begin
  queryMusic.Refresh;
  queryUserData.Refresh;
  tableKeyword.Refresh;
end;


//******************************************************************************
//* Adds keyword into keyword edit box
//******************************************************************************
procedure TformDetailsOfMusic.bitbtnAddToKeywordClick(Sender: TObject);
begin
  MessageDlg('Sorry.  Now under construction', mtInformation, [mbOk], 0);
end;

end.
